# PhasicFlow: ppInteractionFunctor< ContactForceModel, ContactListType > Struct Template Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

ppInteractionFunctor< ContactForceModel, ContactListType > Struct Template Reference

## Public Types

using | PairType = typename ContactListType::PairType
using | ValueType = typename ContactListType::ValueType

## Public Member Functions

| ppInteractionFunctor (real dt, ContactForceModel forceModel, ContactListType tobeFilled, deviceViewType1D< real > diam, deviceViewType1D< uint32 > propId, deviceViewType1D< realx3 > pos, deviceViewType1D< realx3 > lVel, deviceViewType1D< realx3 > rVel, deviceViewType1D< realx3 > cForce, deviceViewType1D< realx3 > cTorque)
INLINE_FUNCTION_HD void | operator() (const uint32 n) const

## Public Attributes

real | dt_
ContactForceModel | forceModel_
ContactListType | tobeFilled_
deviceViewType1D< real > | diam_
deviceViewType1D< uint32 > | propId_
deviceViewType1D< realx3 > | pos_
deviceViewType1D< realx3 > | lVel_
deviceViewType1D< realx3 > | rVel_
deviceViewType1D< realx3 > | cForce_
deviceViewType1D< realx3 > | cTorque_

## Detailed Description

### template<typename ContactForceModel, typename ContactListType>
struct pFlow::sphereInteractionKernels::ppInteractionFunctor< ContactForceModel, ContactListType >

Definition at line 33 of file sphereInteractionKernels.hpp.

## Member Typedef Documentation

## PairType

using PairType = typename ContactListType::PairType

Definition at line 36 of file sphereInteractionKernels.hpp.

## ValueType

using ValueType = typename ContactListType::ValueType

Definition at line 37 of file sphereInteractionKernels.hpp.

## Constructor & Destructor Documentation

## ppInteractionFunctor()

ppInteractionFunctor | ( | real | dt,
|  | ContactForceModel | forceModel,
|  | ContactListType | tobeFilled,
|  | deviceViewType1D< real > | diam,
|  | deviceViewType1D< uint32 > | propId,
|  | deviceViewType1D< realx3 > | pos,
|  | deviceViewType1D< realx3 > | lVel,
|  | deviceViewType1D< realx3 > | rVel,
|  | deviceViewType1D< realx3 > | cForce,
|  | deviceViewType1D< realx3 > | cTorque
| ) |  |

inline

Definition at line 53 of file sphereInteractionKernels.hpp.

## Member Function Documentation

## operator()()

INLINE_FUNCTION_HD void operator() | ( | const uint32 | n | ) | const

inline

Definition at line 78 of file sphereInteractionKernels.hpp.

References ppInteractionFunctor< ContactForceModel, ContactListType >::cForce_, cross(), ppInteractionFunctor< ContactForceModel, ContactListType >::cTorque_, ppInteractionFunctor< ContactForceModel, ContactListType >::diam_, ppInteractionFunctor< ContactForceModel, ContactListType >::dt_, ppInteractionFunctor< ContactForceModel, ContactListType >::forceModel_, length(), ppInteractionFunctor< ContactForceModel, ContactListType >::lVel_, n, ppInteractionFunctor< ContactForceModel, ContactListType >::pos_, ppInteractionFunctor< ContactForceModel, ContactListType >::propId_, ppInteractionFunctor< ContactForceModel, ContactListType >::rVel_, ppInteractionFunctor< ContactForceModel, ContactListType >::tobeFilled_, triple< T >::x_, triple< T >::y_, and triple< T >::z_.

Here is the call graph for this function:

## Member Data Documentation

## dt_

real dt_

Definition at line 39 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## forceModel_

ContactForceModel forceModel_

Definition at line 41 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## tobeFilled_

ContactListType tobeFilled_

Definition at line 42 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## diam_

deviceViewType1D<real> diam_

Definition at line 44 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## propId_

deviceViewType1D<uint32> propId_

Definition at line 45 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## pos_

deviceViewType1D<realx3> pos_

Definition at line 46 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## lVel_

deviceViewType1D<realx3> lVel_

Definition at line 47 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## rVel_

deviceViewType1D<realx3> rVel_

Definition at line 48 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## cForce_

deviceViewType1D<realx3> cForce_

Definition at line 49 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

## cTorque_

deviceViewType1D<realx3> cTorque_

Definition at line 50 of file sphereInteractionKernels.hpp.

Referenced by ppInteractionFunctor< ContactForceModel, ContactListType >::operator()().

The documentation for this struct was generated from the following file:

- src/Interaction/sphereInteraction/sphereInteraction/sphereInteractionKernels.hpp